Index: create_account_action.php
===================================================================
--- create_account_action.php	(Revision 24007)
+++ create_account_action.php	(Arbeitskopie)
@@ -23,21 +23,21 @@
 include_once("../inc/recaptchalib.php");
 
 function show_error($str) {
-    page_head("Can't create account");
+    page_head(tra("Can't create account"));
     echo "$str<br>\n";
     echo BoincDb::error();
-    echo "<p>Click your browser's <b>Back</b> button to try again.\n<p>\n";
+    echo "<p>".tra("Click your browser's <b>Back</b> button to try again.")."\n</p>\n";
     page_tail();
     exit();
 }
 
 $config = get_config();
 if (parse_bool($config, "disable_account_creation")) {
-    page_head("Account creation is disabled");
+    page_head(tra("Account creation is disabled"));
     echo "
-        <h3>Account creation is disabled</h3>
-        Sorry, this project has disabled the creation of new accounts.
-        Please try again later.
+        <h3>".tra("Account creation is disabled")."</h3>
+        ".tra("Sorry, this project has disabled the creation of new accounts.
+Please try again later.")."
     ";
     exit();
 }
@@ -48,7 +48,7 @@
           $_POST["recaptcha_challenge_field"], $_POST["recaptcha_response_field"]
       );
       if (!$resp->is_valid) {
-          echo "" . tra("Your reCAPTCHA response was not correct. Please try again."). "";
+          echo tra("Your reCAPTCHA response was not correct. Please try again.");
           return;
       }
   }
@@ -61,8 +61,7 @@
     $team = lookup_team($teamid);
     $clone_user = lookup_user_id($team->userid);
     if (!$clone_user) {
-        echo "User $userid not found";
-        exit();
+        error_page("User $userid not found");
     }
     $project_prefs = $clone_user->project_prefs;
 } else {
@@ -82,42 +81,37 @@
 
 $new_name = post_str("new_name");
 if (strlen($new_name)==0) {
-    show_error("You must supply a name for your account");
+    show_error(tra("You must supply a name for your account"));
 }
-if ($new_name != strip_tags($new_name)) {
-    show_error("HTML tags not allowed in name");
+if ($new_name != sanitize_tags($new_name)) {
+    show_error(tra("HTML tags not allowed in name"));
 }
 
-$new_email_addr = post_str("new_email_addr");
-$new_email_addr = strtolower($new_email_addr);
+$new_email_addr = strtolower(post_str("new_email_addr"));
 if (!is_valid_email_addr($new_email_addr)) {
-    show_error("Invalid email address:
-        you must enter a valid address of the form
-        name@domain"
-    );
+    show_error(tra("Invalid email address: you must enter a valid address of the form name@domain"));
 }
 $user = lookup_user_email_addr($new_email_addr);
 if ($user) {
-    show_error("There's already an account with that email address.");
+    show_error(tra("There's already an account with that email address."));
 }
 
 $passwd = post_str("passwd");
 $passwd2 = post_str("passwd2");
 if ($passwd != $passwd2) {
-    show_error("New passwords are different");
+    show_error(tra("New passwords are different"));
 }
 
 $min_passwd_length = parse_config($config, "<min_passwd_length>");
 if (!$min_passwd_length) $min_passwd_length = 6;
 
 if (!is_ascii($passwd)) {
-    show_error("Passwords may only include ASCII characters.");
+    show_error(tra("Passwords may only include ASCII characters."));
 }
 
 if (strlen($passwd)<$min_passwd_length) {
     show_error(
-        "New password is too short:
-        minimum password length is $min_passwd_length characters."
+        tra("New password is too short: minimum password length is %1 characters.", $min_passwd_length)
     );
 }
 
@@ -128,18 +122,17 @@
     $country = "International";
 }
 if (!is_valid_country($country)) {
-    echo "bad country";
-    exit();
+    error_page("bad country");
 }
 
-$postal_code = post_str("postal_code", true);
+$postal_code = sanitize_tags(post_str("postal_code", true));
 
 $user = make_user(
     $new_email_addr, $new_name, $passwd_hash,
     $country, $postal_code, $project_prefs, $teamid
 );
 if (!$user) {
-    show_error("Couldn't create account");
+    show_error(tra("Couldn't create account"));
 }
 
 if(defined('INVITE_CODES')) {
Index: forum_search.php
===================================================================
--- forum_search.php	(Revision 24007)
+++ forum_search.php	(Arbeitskopie)
@@ -28,35 +28,35 @@
 
 start_table();
 echo "<form action=\"forum_search_action.php\" method=\"post\">";
-row1("Search query");
-row2("Search for keywords:<br />
-    <span class=\"smalltext\">Posts that contain all the specified words will be displayed</span>",
-    '<input type="text" style="width: 290px" name="search_keywords" size="30" /><br />
-    <span class="smalltext">For example: "screensaver freeze"</span>');
-row2("Search for author ID:<br />
-    <span class=\"smalltext\">Only posts by this author will be displayed</span>",
-    '<input type="text" style="width: 150px" name="search_author" size="10" /><br />
-    <span class="smalltext">For example: "43214"</span>');
+row1(tra("Search query"));
+row2(tra("Search for keywords:")."<br />
+    <span class=\"smalltext\">".tra("Posts that contain all the specified words will be displayed")."</span>",
+    "<input type=\"text\" style=\"width: 290px\" name=\search_keywords\" size=\"30\" /><br />
+    <span class=\"smalltext\">".tra("For example: \"screensaver freeze\"")."</span>");
+row2(tra("Search for author ID:")."<br />
+    <span class=\"smalltext\">".tra("Only posts by this author will be displayed")."</span>",
+    "<input type=\"text\" style=\"width: 150px\" name=\"search_author\" size=\"10\" /><br />
+    <span class=\"smalltext\">".tra("For example: \"43214\"")."</span>");
 
-row1("Search options");
-row2("Search limits<br />
-    <span class=\"smalltext\">Search at most this many days back in time</span>",
-    '<select name="search_max_time">
-    <option value="1">1 day</option>
-    <option value="3">3 days</option>
-    <option value="7">7 days</option>
-    <option value="15">15 days</option>
-    <option value="30" selected>30 days</option>
-    <option value="90">3 months</option>
-    <option value="180">6 months</option>
-    <option value="360">1 year</option>
-    </select>');
+row1(tra("Search options"));
+row2(tra("Search limits")."<br />
+    <span class=\"smalltext\">".tra("Search at most this many days back in time")."</span>",
+    "<select name=\"search_max_time\">
+    <option value=\"1\">".tra("1 day")."</option>
+    <option value=\"3\">".tra("%1 days", "3")."</option>
+    <option value=\"7\">".tra("%1 days", "7")."</option>
+    <option value=\"15\">".tra("%1 days", "15")."</option>
+    <option value=\"30\" selected>".tra("%1 days", "30")."</option>
+    <option value=\"90\">".tra("%1 months", "3")."</option>
+    <option value=\"180\">".tra("%1 months", "6")."</option>
+    <option value=\"360\">".tra("1 year")."</option>
+    </select>");
 
 $forumid = null;
 if (get_str("forumid",true)){
     $forumid = get_str("forumid");
 }
-$forumlist="<option value=\"-1\">All</option>";
+$forumlist="<option value=\"-1\">".tra("All")."</option>";
 $categories = BoincCategory::enum();
 foreach ($categories as $category) {
     $forums = BoincForum::enum("parent_type=0 and category=$category->id");
@@ -68,8 +68,8 @@
         }
     }
 }
-row2("Forum<br />
-    <span class=\"smalltext\">Only display posts from this forum</span>",
+row2(tra("Forum")."<br />
+    <span class=\"smalltext\">".tra("Only display posts from this forum")."</span>",
     '<select name="search_forum">'.$forumlist.'</select');
 
 $sortlist = null;
@@ -80,16 +80,15 @@
         $sortlist.="<option value=\"".$id."\">".$style."</option>";
     }
 }
-row2("Sort by", 
+row2(tra("Sort by"), 
     '<select name="search_sort">'.$sortlist.'</select');
 
 row1("&nbsp;");
-row2("","<input type=\"submit\" value=\"Start the search\">");
+row2("","<input type=\"submit\" value=\"".tra("Start the search")."\">");
 echo "</form>";
 end_table();
 
 page_tail();
-exit;
 
 $cvs_version_tracker[]="\$Id$";  //Generated automatically - do not edit
 ?>
Index: bbcode.php
===================================================================
--- bbcode.php	(Revision 24007)
+++ bbcode.php	(Arbeitskopie)
@@ -20,37 +20,37 @@
 
 check_get_args(array());
 
-page_head("BBCode tags");
+page_head(tra("BBCode tags"));
 echo "<p>
-BBCode tags let you format text in your profile and message-board postings.
+".tra("BBCode tags let you format text in your profile and message-board postings.
 It's similar to HTML, but simpler. The tags start with a [ (where you would
-have used &lt; in HTML) and end with ] (where you would have used &gt; in
-HTML).</p>";
+have used %1 in HTML) and end with ] (where you would have used %2 in
+HTML).", "&lt;", "&gt;")."</p>";
 
 start_table();
-row1("Examples");
-row2_plain("[b]Bold[/b]", "<b>Bold</b>");
-row2_plain("[i]Italic[/i]", "<i>Italic</i>");
-row2_plain("[u]Underline[/u]", "<u>Underline</u>");
-row2_plain("[size=15]Big text[/size]", "<span style=\"font-size: 15px\">Big text</span>");
-row2_plain("[color=red]Red text[/color]", "<font color=\"red\">Red text</font></li>");
-row2_plain("[url=http://google.com/]Google[/url]", "<a href=\"http://google.com/\">Google</a>");
-row2_plain("[quote]Quoted text[/quote]", "use for quoted blocks of text");
-row2_plain("[img]http://example.com/pic.jpg[/img]", "use to display an image");
-row2_plain("[code]Code snippet here[/code]", "use to display some code");
-row2_plain("[pre]Pre-formatted text[/pre]", "use to display pre-formatted (usually monospaced) text");
-row2_plain("[list]<br>* Item 1<br>*Item2<br>[/list]", "<ul><li>Item 1</li><li>Item 2</li></ul>");
+row1(tra("Examples"));
+row2_plain("[b]".tra("Bold")."[/b]", "<b>".tra("Bold")."</b>");
+row2_plain("[i]".tra("Italic")."[/i]", "<i>".tra("Italic")."</i>");
+row2_plain("[u]".tra("Underline")."[/u]", "<u>".tra("Underline")."</u>");
+row2_plain("[size=15]".tra("Big text")."[/size]", "<span style=\"font-size: 15px\">".tra("Big text")."</span>");
+row2_plain("[color=red]".tra("Red text")."[/color]", "<font color=\"red\">".tra("Red text")."</font></li>");
+row2_plain("[url=http://google.com/]".tra("link to website")."[/url]", "<a href=\"http://google.com/\">".tra("link to website")."</a>");
+row2_plain("[quote]".tra("Quoted text")."[/quote]", tra("use for quoted blocks of text"));
+row2_plain("[img]http://example.com/pic.jpg[/img]", tra("use to display an image"));
+row2_plain("[code]".tra("Code snippet here")."[/code]", tra("use to display some code"));
+row2_plain("[pre]".tra("Pre-formatted text")."[/pre]", tra("use to display pre-formatted (usually monospaced) text"));
+row2_plain("[list]<br>* ".tra("Item 1")."<br>* ".tra("Item2")."<br>[/list]", "<ul><li>".tra("Item 1")."</li><li>".tra("Item 2")."</li></ul>");
 row2_plain("[trac]#1[/trac] or [trac]ticket:1[/trac]",
-    "use to link to Trac ticket on BOINC website: <a href=\"http://boinc.berkeley.edu/trac/ticket/1\">#1</a>");
+    tra("use to link to Trac ticket on BOINC website").": <a href=\"http://boinc.berkeley.edu/trac/ticket/1\">#1</a>");
 row2_plain("[trac]wiki:WebForum[/trac]",
-    "use to link to Trac Wiki on BOINC website: <a href=\"http://boinc.berkeley.edu/trac/wiki/WebForum\">WebForum</a>");
+    tra("use to link to Trac Wiki on BOINC website").": <a href=\"http://boinc.berkeley.edu/trac/wiki/WebForum\">WebForum</a>");
 row2_plain("[trac]changeset:12345[/trac]",
-    "use to link to SVN changeset on BOINC website: <a href=\"http://boinc.berkeley.edu/trac/changeset/12345\">[12345]</a>");
+    tra("use to link to SVN changeset on BOINC website").": <a href=\"http://boinc.berkeley.edu/trac/changeset/12345\">[12345]</a>");
 end_table();
 
 echo "<p>
-If you don't close a tag or don't specify a parameter correctly,
-the raw tag itself will display instead of the formatted text.</p>
+".tra("If you don't close a tag or don't specify a parameter correctly,
+the raw tag itself will display instead of the formatted text.")."</p>
 ";
 page_tail();
 ?>
Index: forum_thread.php
===================================================================
--- forum_thread.php	(Revision 24007)
+++ forum_thread.php	(Arbeitskopie)
@@ -44,7 +44,7 @@
 }
 
 if ($threadid < 1) {
-    error_page(tra("Invalid thread ID!"));
+    error_page("Invalid thread ID!");
 }
 
 $thread = BoincThread::lookup_id($threadid);
@@ -66,9 +66,7 @@
         if ($logged_in_user) {
             remove_subscriptions_forum($logged_in_user->id, $thread->id);
         }
-        error_page(
-            tra("This thread has been hidden by moderators")
-        );
+        error_page(tra("This thread has been hidden by moderators."));
     }
 }
 
@@ -242,14 +240,14 @@
     if ($thread->status) {
         show_button(
             "forum_thread_status.php?action=clear&id=$thread->id",
-            "Export",
-            "Export this news item as a Notice"
+            tra("Export"),
+            tra("Export this news item as a Notice")
         );
     } else {
         show_button(
             "forum_thread_status.php?action=set&id=$thread->id",
-            "Don't export",
-            "Don't export this news item as a Notice"
+            tra("Don't export"),
+            tra("Don't export this news item as a Notice")
         );
     }
 }
@@ -259,7 +257,7 @@
     <input type=\"hidden\" name=\"id\" value=\"", $thread->id, "\">" .
     tra("Sort");
 echo select_from_array("sort", $thread_sort_styles, $sort_style);
-echo "<input type=\"submit\" value=\"Sort\">
+echo "<input type=\"submit\" value=\"tra(Sort)\">
     </td></tr></table></form>
 ";
 
Index: home.php
===================================================================
--- home.php	(Revision 24007)
+++ home.php	(Arbeitskopie)
@@ -42,10 +42,8 @@
     page_head(tra("Welcome to %1", PROJECT));
     echo "<p>".tra("View and edit your account preferences using the links below.")."</p>\n";
     if ($via_web) {
-        echo "
-            <p> If you have not already done so,
-            <a href=\"http://boinc.berkeley.edu/download.php\">download BOINC client software</a>.</p>
-        ";
+        echo "<p> "
+        .tra("If you have not already done so, %1download BOINC client software%2.", "<a href=\"http://boinc.berkeley.edu/download.php\">", "</a>")."</p>";
     }
 } else {
     page_head(tra("Your account"));
Index: forum_report_post.php
===================================================================
--- forum_report_post.php	(Revision 24007)
+++ forum_report_post.php	(Arbeitskopie)
@@ -42,7 +42,7 @@
 //
 
 if ($user->total_credit<$forum->rate_min_total_credit || $user->expavg_credit<$forum->rate_min_expavg_credit) {
-    error_page("You need more average or total credit to report a post.");
+    error_page(tra("You need more average or total credit to report a post."));
 }
 
 //__-------------- Action part
@@ -61,44 +61,36 @@
 
 //__--------------- Display part
 if ($success_page==1) {
-    page_head('Report Registered');
-    echo "Your report has been recorded.
-        Thanks for your input.
-        <p>
-        A moderator will now look at your report and decide what will happen -
-        this may take a little while, so please be patient.
-    ";
-    echo "<a href=\"forum_thread.php?id=", $thread->id, "#", $post->id, "\">Return to thread</a>";
+    page_head(tra("Report Registered"));
+    echo tra("Your report has been recorded. Thanks you for your input.")."<p>"
+        .tra("A moderator will now look at your report and decide what will happen - this may take a little while, so please be patient");
+
+    echo "<a href=\"forum_thread.php?id=", $thread->id, "#", $post->id, "\">".tra("Return to thread")."</a>";
 } elseif ($success_page==0){
-    page_head('Report a forum post');
+    page_head(".tra(""Report a forum post"").");
     if (!$no_forum_rating) {
-        echo "<p>Before reporting this post,
-            consider using the +/- rating system instead.
-            If enough users rate a post negatively it will eventually be hidden.
-            <br>You can find the rating system at the bottom of the post.
+        echo "<p>".tra("Before reporting this post, consider using the +/- rating system instead. If enough users rate a post negatively it will eventually be hidden.<br />You can find the rating system at the bottom of the post.")."</p>
         ";
     }
     start_forum_table(array(tra("Author"), tra("Message"),""));
     show_post($post, $thread, $forum, $user, 0, 0);
     echo "<form action=\"forum_report_post.php\" method=\"get\">\n";
     echo form_tokens($user->authenticator);
-    row1("Report post");
-    row2("Why do you find the post offensive:<br><font size=-1>Please include enough information so that a person that
-    has not yet read the thread will quickly be able to identify the issue.</font>",
+    row1(tra("Report post"));
+    row2(tra("Why do you find the post offensive: %1Please include enough information so that a person that
+has not yet read the thread will quickly be able to identify the issue.%2", "<span class=\"smalltext\">", "</span>"),
         "<textarea name=\"reason\" rows=12 cols=54></textarea>"
     );
-    row2("", "<input type=\"submit\" name=\"submit\" value=\"OK\">");
+    row2("", "<input type=\"submit\" name=\"submit\" value=\"".tra("OK")."\">");
     echo "<input type=\"hidden\" name=\"post\" value=\"".$post->id."\">";
     echo "</form>";
     end_table();
 } elseif ($success_page==-1) {
-    page_head('Report not registered');
-    echo "<p>Your report could not be recorded.
-        Please wait a while and try again.
-        <p>If this is not a temporary error,
-        please report it to the project developers.
+    page_head(tra("Report not registered"));
+    echo "<p>".tra("Your report could not be recorded. Please wait a while and try again.")."</p>
+        <p>".tra("If this is not a temporary error, please report it to the project developers.")."</p>
     ";
-    echo "<a href=\"forum_thread.php?id=", $thread->id, "#", $post->id, "\">Return to thread</a>";
+    echo "<a href=\"forum_thread.php?id=", $thread->id, "#", $post->id, "\">".tra("Return to thread")."</a>";
 }
 page_tail();
 ?>
Index: account_finish_action.php
===================================================================
--- account_finish_action.php	(Revision 24007)
+++ account_finish_action.php	(Arbeitskopie)
@@ -24,18 +24,18 @@
 $name = post_str("name");
 
 if (strlen($name)==0) {
-    error_page("You must supply a name for your account");
+    error_page(tra("You must supply a name for your account"));
 }
-if ($new_name != strip_tags($new_name)) {
-    error_page("HTML tags not allowed in name");
+if ($new_name != sanitize_tags($new_name)) {
+    error_page(tra("HTML tags not allowed in name"));
 }
 
 $country = post_str("country");
 if (!is_valid_country($country)) {
-    error_page( "invalid country");
+    error_page("invalid country");
 }
 $country = BoincDb::escape_string($country);
-$postal_code = BoincDb::escape_string(strip_tags(post_str("postal_code", true)));
+$postal_code = BoincDb::escape_string(sanitize_tags(post_str("postal_code", true)));
 $auth = BoincDb::escape_string($auth);
 
 $name = BoincDb::escape_string($name);
Index: get_passwd.php
===================================================================
--- get_passwd.php	(Revision 24007)
+++ get_passwd.php	(Arbeitskopie)
@@ -22,15 +22,11 @@
 
 check_get_args(array());
 
-page_head("Forgot your account info?");
+page_head(tra("Forgot your account info?"));
 
-echo "
-<h3>1) If you know your account's email address,
-    and you can receive email there:</h3>
-<p>
-Enter the email address below, and click OK.
-You will be sent email instructions for resetting your password.
-";
+echo "<h3>"
+    .tra("1) If you know your account's email address, and you can receive email there:")."</h3><p>"
+    .tra("Enter the email address below, and click OK. You will be sent email instructions for resetting your password.");
 
 $master_url = parse_config(get_config(), "<master_url>");
 $x = strstr($master_url, "//");
@@ -41,27 +37,19 @@
 
 start_table();
 echo "<form method=post action=mail_passwd.php>\n";
-row2("Email address","<input type=\"text\" size=40 name=email_addr>");
-row2("", "<input type=submit value=OK>");
+row2(tra("Email address"),"<input type=\"text\" size=40 name=email_addr>");
+row2("", "<input type=submit value=\"".tra("OK")."\">");
 echo "</form>";
 end_table();
 
-echo "
-<p>
-<h3>2) If you forgot your account's email address,
-or you can't receive email there:</h3>
+echo "<p><h3>"
+    .tra("2) If you forgot your account's email address, or you can't receive email there:")."</h3>"
+    .tra("If you have run BOINC under this account, you can still access it. Here's how:")."
 
-If you have run BOINC under the account,
-you can still access it.
-Here's how:
-
 <ul>
-<li> Go to the BOINC data directory on your computer
-(on Windows this is usually <b>C:\\Documents and Settings\All Users\Application Data\BOINC</b> or <b>C:\\Program Files\BOINC</b>.
-<li> Find your account file for this project;
-it will be named <b>$account_file</b>.
-<li> Open the file in a text editor like Notepad.
-You'll see something like
+<li> ".tra("Go to the BOINC data directory on your computer (on Windows this is usually <b>C:\\Documents and Settings\All Users\Application Data\BOINC</b> or <b>C:\\Program Files\BOINC</b>.")."
+<li> ".tra("Find your account file for this project; it will be named <b>%1</b>.", $account_file)."
+<li> ".tra("Open the file in a text editor like Notepad. You'll see something like")."
 <pre>
 &lt;account>
     &lt;master_url>http://lhcathome.cern.ch/&lt;/master_url>
@@ -71,23 +59,20 @@
 &lt;/account>
 </pre>
 
-<li> Select and Copy the string between &lt;authenticator>
-and &lt;/authenticator>
-(<b>8b8496fdd26df7dc0423ecd43c09a56b</b> in the above example).
+<li> ".tra("Select and Copy the string between %1 and %2 (%3 in the above example).", "&lt;authenticator>", "&lt;/authenticator>", "<b>8b8496fdd26df7dc0423ecd43c09a56b</b>")."
 
-<li> Paste the string into the field below, and click OK.
-<li> You will now be logged in to your account;
-update the email and password of your account.
+<li> ".tra("Paste the string into the field below, and click OK.")."
+<li> ".tra("You will now be logged in to your account; update the email and password of your account.")."
 </ul>
 ";
 start_table();
 
 echo "<form action=login_action.php method=post>\n";
-row2("Log in with authenticator", "<input type=\"text\" name=authenticator size=40>");
-row2("Stay logged in on this computer",
+row2(tra("Log in with authenticator"), "<input type=\"text\" name=authenticator size=40>");
+row2(tra("Stay logged in on this computer"),
     "<input type=checkbox name=send_cookie checked>"
 );
-row2("", "<input type=submit value=OK>");
+row2("", "<input type=submit value=\"".tra("OK")."\">");
 echo "</form>";
 
 end_table();
Index: forum_rate.php
===================================================================
--- forum_rate.php	(Revision 24007)
+++ forum_rate.php	(Arbeitskopie)
@@ -23,8 +23,8 @@
 
 $config = get_config();
 if (parse_bool($config, "no_forum_rating")) {
-    page_head("Rating offline");
-    echo "This function is turned off by the project";
+    page_head(tra("Rating offline"));
+    echo tra("This function is turned off by the project");
     page_tail();
     exit(0);
 }
@@ -55,11 +55,11 @@
     // before allowing them to rate a post.
     //
     if ($user->total_credit<$forum->rate_min_total_credit || $user->expavg_credit<$forum->rate_min_expavg_credit) {
-        error_page("You need more average or total credit to rate a post.");
+        error_page(tra("You need more average or total credit to rate a post."));
     }
     
     if (BoincPostRating::lookup($user->id, $post->id)) {
-        error_page("You have already rated this post.<br /><br /><a href=\"forum_thread.php?nowrap=true&id=".$thread->id."#".$post->id."\">Return to thread</a>");
+        error_page(tra("You have already rated this post.")."<br /><br /><a href=\"forum_thread.php?nowrap=true&id=".$thread->id."#".$post->id."\">".tra("Return to thread")."</a>");
     } else {
         $success = BoincPostRating::replace($user->id, $post->id, $rating);
         show_result_page($success, $post, $thread, $choice);
@@ -69,20 +69,20 @@
 function show_result_page($success, $post, $thread, $choice) {
     if ($success) {
         if ($choice) {
-            page_head('Input Recorded');
-                echo "Your input has been recorded.  Thanks for your help.";
+            page_head(tra("Input Recorded"));
+                echo tra("Your input has been recorded. Thanks for your help.");
         } else {
-            page_head('Vote Registered');
-            echo "Your rating has been recorded.  Thanks for your input.";
+            page_head(tra("Vote Registered"));
+            echo tra("Your rating has been recorded. Thanks for your input.");
         }
-        echo "<a href=\"forum_thread.php?nowrap=true&id=", $thread->id, "#", $post->id, "\">Return to thread</a>";
+        echo "<a href=\"forum_thread.php?nowrap=true&id=", $thread->id, "#", $post->id, "\">".tra("Return to thread")."</a>";
     } else {
-        page_head('Vote Submission Problem');    
+        page_head(tra("Vote Submission Problem"));    
         if ($post) {
-            echo "There was a problem recording your vote in our database.  Please try again later.";
-            echo "<a href=\"forum_thread.php?id=", $thread->id, "#", $post->id, "\">Return to thread</a>";
+            echo tra("There was a problem recording your vote in our database. Please try again later.");
+            echo "<a href=\"forum_thread.php?id=", $thread->id, "#", $post->id, "\">".tra("Return to thread")."</a>";
         } else {
-            echo "The post you specified does not exist, or your rating was invalid.";
+            echo tra("The post you specified does not exist, or your rating was invalid.");
         }
     }
     page_tail();
Index: host_app_versions.php
===================================================================
--- host_app_versions.php	(Revision 24007)
+++ host_app_versions.php	(Arbeitskopie)
@@ -22,29 +22,29 @@
 
 function rsc_name($t) {
     switch ($t) {
-    case 2: return "CPU";
-    case 3: return "nvidia GPU";
-    case 4: return "ATI GPU";
+    case 2: return tra("CPU");
+    case 3: return tra("nvidia GPU");
+    case 4: return tra("ATI GPU");
     }
-    return "Unknown";
+    return tra("Unknown");
 }
 
 function av_desc($gavid) {
     if ($gavid >= 1000000) {
         $appid = (int)($gavid/1000000);
         $app = BoincApp::lookup_id($appid);
-        if (!$app) return "Anonymous platform, missing app";
+        if (!$app) return tra("Anonymous platform, missing app");
         $rsc_type = $gavid % 1000000;
         $r = rsc_name($rsc_type);
-        return "$app->user_friendly_name (anonymous platform, $r)";
+        return "$app->user_friendly_name (".tra("anonymous platform").", $r)";
 
     } else {
         $av = BoincAppVersion::lookup_id($gavid);
-        if (!$av) return "Missing app version";
+        if (!$av) return tra("Missing app version");
         $app = BoincApp::lookup_id($av->appid);
-        if (!$app) return "Missing app";
+        if (!$app) return tra("Missing app");
         $platform = BoincPlatform::lookup_id($av->platformid);
-        if (!$platform) return "Missing platform";
+        if (!$platform) return tra("Missing platform");
         $pc = (strlen($av->plan_class))?"($av->plan_class)":"";
         $v = number_format($av->version_num/100, 2);
         return "$app->user_friendly_name $v $platform->name $pc";
@@ -53,16 +53,16 @@
 
 function show_hav($hav) {
     row1(av_desc($hav->app_version_id));
-    row2("Number of tasks completed", $hav->pfc_n);
-    row2("Max tasks per day", $hav->max_jobs_per_day);
-    row2("Number of tasks today", $hav->n_jobs_today);
-    row2("Consecutive valid tasks", $hav->consecutive_valid);
+    row2(tra("Number of tasks completed"), $hav->pfc_n);
+    row2(tra("Max tasks per day"), $hav->max_jobs_per_day);
+    row2(tra("Number of tasks today"), $hav->n_jobs_today);
+    row2(tra("Consecutive valid tasks"), $hav->consecutive_valid);
     $x = number_format($hav->turnaround_avg/86400, 2);
     if ($hav->et_avg) {
         $gflops = 1e-9/$hav->et_avg;
-        row2("Average processing rate", $gflops);
+        row2(tra("Average processing rate"), $gflops);
     }
-    row2("Average turnaround time", "$x days");
+    row2(tra("Average turnaround time"), "$x days");
 }
 
 $hostid = get_int('hostid');
Index: forum_help_desk.php
===================================================================
--- forum_help_desk.php	(Revision 24007)
+++ forum_help_desk.php	(Arbeitskopie)
@@ -24,13 +24,11 @@
 
 $user = get_logged_in_user(false);
 
-page_head("Questions and answers");
+page_head(tra("Questions and answers"));
 
-echo "<p>
-    Talk live via Skype with a volunteer, in any of several languages.
-    Go to
-    <a href=\"http://boinc.berkeley.edu/help.php\">BOINC Online Help</a>.</p>
-";
+echo "<p>".
+    tra("Talk live via Skype with a volunteer, in any of several languages. Go to %1BOINC Online Help%2.", "<a href=\"http://boinc.berkeley.edu/help.php\">", "</a>").
+    "</p>";
 
 show_forum_header($user);
 
@@ -44,7 +42,7 @@
         show_mark_as_read_button($user);
         start_forum_table(array(
             tra("Topic"),
-            tra("# Questions"),
+            tra("Questions"),
             tra("Last post")
         ));
     }
